#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <errno.h>

int getaddrinfo(const char *node, const char *service,
                const struct addrinfo *hints,
                struct addrinfo **res) {
  static int (*libgetaddrinfo)(const char *node, const char *service,
                               const struct addrinfo *hints,
                               struct addrinfo **res) = NULL;
  if (!libgetaddrinfo) {
    libgetaddrinfo = dlsym(RTLD_NEXT, "getaddrinfo");
  }

  int rv = libgetaddrinfo(node, service, hints, res);
  if (rv == 0) {
    return 0;
  }

  fprintf(stderr, "getaddrinfo failed: node=%s, retval=%d, errno=%d\n", node, rv, errno);
  return rv;
}
